
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <tchar.h>
#include <shlwapi.h>

#include "ArrayList_t.h"
#include "AlphaAnalysis.h"

// }N֐
#define GET_BGR(buf,x,y) ((((buf)[((x)+((y)*(width)))])>>8)&0x00FFFFFF)
#define SET_BGR(buf,x,y,val) (((buf)[((x)+((y)*(width)))])=(((buf)[((x)+((y)*(width)))])&0x000000FF)|(((val)<<8)&0xFFFFFF00))
#define GET_ALPHA(buf,x,y) (((buf)[((x)+((y)*(width)))])&0x000000FF)



static arraylist_t *alphaAnalysis(const unsigned int *img_buf, unsigned int width, unsigned int height, int chipCnt, int cx, int cy, int cw, int ch, unsigned int trColor, LPTSTR error_str);

// 摜p^[𕪐 //
arraylist_t *imageAnalysis(const unsigned int *img_buf, unsigned int width, unsigned int height, LPTSTR error_str) {
	unsigned int x, y, cx, cy, cw, ch, xx, yy;
	unsigned int col, bgColor, trColor;
	int i, size, chipF = 0, chipCnt = 0, error = 0, r_val;
	arraylist_t *all_data = NULL;
	arraylist_t *r_data, *temp_data;
	unsigned int *temp_img_buf;
	
	
	// TCYȂ番͂Ȃ
	if (width < 5 || height < 4) { error = -1; goto errorLabel; }
	
	// t@Cۑp̃f[^
	all_data = arraylist_create(sizeof(arraylist_t *));
	if (all_data == NULL) { error = -2; goto errorLabel; }
	
	// img_bufRs[
	temp_img_buf = malloc(width * height * sizeof(unsigned int));
	if (temp_img_buf == NULL) { error = -2; goto errorLabel; }
	memcpy(temp_img_buf, img_buf, width * height * sizeof(unsigned int));
	
	
	bgColor = GET_BGR(temp_img_buf, 0, 0);
	for (y = 0; y < height-1; y++) {
		for (x = 0; x < width-1; x++) {
			col = GET_BGR(temp_img_buf, x, y);
			
			if (col != bgColor) {
				chipF = 1; // `bv͒
				trColor = col; // ߐFL
				//printf("bgColor: %08X  trColor: (%08X)\n", bgColor, trColor);
				
				// `bv̕`FbN //
				for (cx = x+1; cx < width-1; cx++) {
					col = GET_BGR(temp_img_buf, cx, y);
					//printf("scanX: (%d, %d) = %08X\n", cx, y, col);
					if (col == bgColor) { chipF = 2; break; }
				}
				
				cw = cx - x;
				if (cw < 3 || chipF != 2) { error = -1; goto errorLabel; } // R͉摜łȂ/摜E[߂˃G[
				
				// `bv̍`FbN //
				cx--;
				for (cy = y+1; cy < height-1; cy++) {
					col = GET_BGR(temp_img_buf, cx, cy);
					//printf("scanY: (%d, %d) = %08X\n", cx, cy, col);
					if (col == bgColor) { chipF = 3; break; }
				}
				ch = cy - y;
				if (ch < 3) { error = -1; goto errorLabel; } // R͉摜łȂ˃G[ (Tonyu͉ŉ摜r؂ĂĂ̂ǂ߂Ă܂)
				
				//printf("chip: %d x: %d y: %d w: %d h: %d \n", chipCnt, x+1, y+1, cw-2, ch-2);
				
				// p^[Ȃ
				if (chipCnt > 65535) { error = -3; goto errorLabel; }
				
				
				// At@[l
				r_data = alphaAnalysis(temp_img_buf, width, height, chipCnt, x+1, y+1, cw-2, ch-2, trColor, error_str);
				if (r_data == NULL) { error = -2; goto errorLabel; }
				
				
				// t@Cɏރf[^ //
				{
					int data_len, line_sw;
					
					data_len = arraylist_length(r_data);
					line_sw  = (int) *((unsigned char *)arraylist_get(r_data, data_len - 1));
					
					temp_data = arraylist_create(sizeof(unsigned char));
					arraylist_uchar_add(temp_data, (unsigned char)(((data_len - 1) / (1+(line_sw != 2))) >> 24)); // Pp^[̕f[^̒
					arraylist_uchar_add(temp_data, (unsigned char)(((data_len - 1) / (1+(line_sw != 2))) >> 16)); // line_sw != 2 ̏ꍇAQoCgłPZbgȂ̂2Ŋ
					arraylist_uchar_add(temp_data, (unsigned char)(((data_len - 1) / (1+(line_sw != 2))) >>  8)); // line_sw == 2 ̏ꍇAPoCgłPZbgȂ̂2ŊȂ
					arraylist_uchar_add(temp_data, (unsigned char)(((data_len - 1) / (1+(line_sw != 2)))      ));
					arraylist_uchar_add(temp_data, (unsigned char)(line_sw)); // т̕ (0: 1:c)
					arraylist_uchar_add(temp_data, (unsigned char)((trColor) >> 16)); // F
					arraylist_uchar_add(temp_data, (unsigned char)((trColor) >>  8));
					arraylist_uchar_add(temp_data, (unsigned char)((trColor)      ));
					arraylist_add(all_data, &temp_data); // Pp^[̃wb_[t@C
					
					arraylist_add(all_data, &r_data); // f[^
				}
				
				
				
				// ǂݎ摜͔wiFœhԂĂ
				for (yy = y; yy < y+ch+1; yy++) {
					for (xx = x; xx < x+cw+1; xx++) {
						SET_BGR(temp_img_buf, xx, yy, bgColor);
					}
				}
				chipF = 0; // `bv͏I
				chipCnt ++;
				x += cw;
			}
			
			
			
			
			//printf("%08X ", col);
		}
	}
	
	
	
	errorLabel:
	
	if (error == -1) {
		//lstrcpy(error_str, _T("t@C͂ɎsBPp^[Ƃĕ͂܂"));
		printf("x : %s\n", "t@C͂ɎsBPp^[Ƃĕ͂܂");
		error = 0;
		
		// z폜 //
		size = arraylist_length(all_data);
		for (i = 0; i < size; i++) {
			temp_data = *((arraylist_t **)(arraylist_get(all_data, i)));
			arraylist_release(temp_data);
		}
		arraylist_clear(all_data);
		
		// Pp^[̉摜Ƃčĕ //
		trColor = GET_BGR(img_buf, 0, 0); // ߐFL
		
		// At@[l
		r_data = alphaAnalysis(img_buf, width, height, 0, 1, 1, width - 1, height - 1, trColor, error_str);
		if (r_data == NULL) { error = -2; goto errorLabel2; }
		
		// t@Cɏރf[^ //
		{
			int data_len, line_sw;
			
			data_len = arraylist_length(r_data);
			line_sw  = (int) *((unsigned char *)arraylist_get(r_data, data_len - 1));
			
			temp_data = arraylist_create(sizeof(unsigned char));
			arraylist_uchar_add(temp_data, (unsigned char)(((data_len - 1) / (1+(line_sw != 2))) >> 24)); // Pp^[̕f[^̒
			arraylist_uchar_add(temp_data, (unsigned char)(((data_len - 1) / (1+(line_sw != 2))) >> 16)); // line_sw != 2 ̏ꍇAQoCgłPZbgȂ̂2Ŋ
			arraylist_uchar_add(temp_data, (unsigned char)(((data_len - 1) / (1+(line_sw != 2))) >>  8)); // line_sw == 2 ̏ꍇAPoCgłPZbgȂ̂2ŊȂ
			arraylist_uchar_add(temp_data, (unsigned char)(((data_len - 1) / (1+(line_sw != 2)))      ));
			arraylist_uchar_add(temp_data, (unsigned char)(line_sw)); // т̕ (0: 1:c)
			arraylist_uchar_add(temp_data, (unsigned char)((trColor) >> 16)); // F
			arraylist_uchar_add(temp_data, (unsigned char)((trColor) >>  8));
			arraylist_uchar_add(temp_data, (unsigned char)((trColor)      ));
			arraylist_add(all_data, &temp_data); // Pp^[̃wb_[t@C
			
			arraylist_add(all_data, &r_data); // f[^
		}
	}
	
	errorLabel2:
	if      (error == -2) lstrcpy(error_str, _T("mۂɎs"));
	else if (error == -3) lstrcpy(error_str, _T("Pt@CAp^[65535𒴂摜ɂ͑ΉĂ܂"));
	
	// Ɨpf[^
	free(temp_img_buf);
	
	if (error == 0) {
		return all_data;
		
	} else {
		// G[Ȃf[^̃
		if (all_data) {
			size = arraylist_length(all_data);
			for (i = 0; i < size; i++) {
				temp_data = *((arraylist_t **)(arraylist_get(all_data, i)));
				arraylist_release(temp_data);
			}
			arraylist_release(all_data);
		}
		
		return NULL;
	}
}



// At@[l𕪐 //
static arraylist_t *alphaAnalysis(const unsigned int *img_buf, unsigned int width, unsigned int height, int chipCnt, int cx, int cy, int cw, int ch, unsigned int trColor, LPTSTR error_str) {
	arraylist_t *aryW, *aryH, *aryOneByte, *returnArrayList;
	int error = 0, i, x, y, xStart, xLen, yStart, yLen, rVal;
	unsigned int alpha, alphaStart = 0xFFFFFFFF, col;
	
	
	//  //
	aryW = arraylist_create(sizeof(unsigned char));
	if (aryW == NULL) { error = -9; goto errorLabel; }
	for (y = cy; y < cy + ch; y++) {
		//printf("-row : %3d ---\n", y - cy);
		for (x = cx; x <= cx + cw; x++) {
			if (x < cx + cw) {
				alpha = GET_ALPHA(img_buf, x, y);
				col = GET_BGR(img_buf, x, y);
				if (col == trColor) alpha = 0; // FȂsłȂĂsɂ
			} else {
				alpha = 0xFFFFFFF0;
			}
			xLen = x - xStart - 1; // At@[l̘A
			if (alpha != alphaStart || xLen >= 255) {
				if (alphaStart != 0xFFFFFFFF) { // At@[lωꍇ
					rVal = arraylist_uchar_add(aryW, (unsigned char)(alphaStart)); // At@[l
					if (rVal == -1) { error = -1; goto errorLabel; }
					rVal = arraylist_uchar_add(aryW, (unsigned char)(xLen));       // At@[l̑т̒
					if (rVal == -1) { error = -1; goto errorLabel; }
					//printf("%02X %02X ", (unsigned char)(alphaStart), (unsigned char)(xLen));
				}
				alphaStart = alpha; // ݂̃At@[l
				xStart = x; // ݂̃At@[l̈ʒu
			}
		}
		// Zbg
		alphaStart = 0xFFFFFFFF;
		xStart = x;
	}
	
	
	// c //
	aryH = arraylist_create(sizeof(unsigned char));
	if (aryH == NULL) { error = -1; goto errorLabel; }
	for (x = cx; x < cx + cw; x++) {
		//printf("-column : %3d ---\n", x - cx);
		for (y = cy; y <= cy + ch; y++) {
			if (y < cy + ch) {
				alpha = GET_ALPHA(img_buf, x, y);
				col = GET_BGR(img_buf, x, y);
				if (col == trColor) alpha = 0; // FȂsłȂĂsɂ
			} else {
				alpha = 0xFFFFFFF0;
			}
			yLen = y - yStart - 1; // At@[l̘A
			if (alpha != alphaStart || yLen >= 255) {
				if (alphaStart != 0xFFFFFFFF) { // At@[lωꍇ
					rVal = arraylist_uchar_add(aryH, (unsigned char)(alphaStart)); // At@[l
					if (rVal == -1) { error = -2; goto errorLabel; }
					rVal = arraylist_uchar_add(aryH, (unsigned char)(yLen));       // At@[l̑т̒
					if (rVal == -1) { error = -2; goto errorLabel; }
					//printf("%02X %02X ", (unsigned char)(alphaStart), (unsigned char)(yLen));
				}
				alphaStart = alpha; // ݂̃At@[l
				yStart = y; // ݂̃At@[l̈ʒu
			}
		}
		// Zbg
		alphaStart = 0xFFFFFFFF;
		yStart = y;
	}
	
	
	//printf("lengthW = %d\n", arraylist_length(aryW));
	//printf("lengthH = %d\n", arraylist_length(aryH));
	
	// f[^ʂ̏ȂԂ //
	if ((cw * ch) < arraylist_length(aryW) && (cw * ch) < arraylist_length(aryH)) {
		
		// 1hbg1oCg[h̔z
		aryOneByte = arraylist_create(sizeof(unsigned char));
		if (aryOneByte == NULL) return NULL;
		for (y = cy; y < cy + ch; y++) {
			for (x = cx; x < cx + cw; x++) {
				alpha = GET_ALPHA(img_buf, x, y);
				col = GET_BGR(img_buf, x, y);
				if (col == trColor) alpha = 0; // FȂsłȂĂsɂ
				
				rVal = arraylist_uchar_add(aryOneByte, (unsigned char)(alpha)); // At@[l
				if (rVal == -1) { error = -3; goto errorLabel; }
			}
		}
		
		rVal = arraylist_uchar_add(aryOneByte, 2); // 1hbg1oCg[h̃tOt
		if (rVal == -1) { error = -3; goto errorLabel; }
		returnArrayList = aryOneByte;
		arraylist_release(aryW);
		arraylist_release(aryH);
		
	} else {
		if (arraylist_length(aryW) <= arraylist_length(aryH)) {
			rVal = arraylist_uchar_add(aryW, 0); // tOt
			if (rVal == -1) { error = -2; goto errorLabel; }
			returnArrayList = aryW;
			arraylist_release(aryH);
		} else {
			rVal = arraylist_uchar_add(aryH, 1); // ctOt
			if (rVal == -1) { error = -2; goto errorLabel; }
			returnArrayList = aryH;
			arraylist_release(aryW);
		}
	}
	
	errorLabel:
	if (error != 0) {
		if      (error == -1) arraylist_release(aryW);
		else if (error == -2) { arraylist_release(aryW); arraylist_release(aryH); }
		else if (error == -3) { arraylist_release(aryW); arraylist_release(aryH); arraylist_release(aryOneByte); }
		return NULL;
	}
	
	return returnArrayList;
}



// t@C //
int alphaDataWriteFile(LPCTSTR fileName, arraylist_t *mask_data, LPTSTR error_str) {
	LPCTSTR MY_LIB_EXTENSION = _T(".tal"); // gq
	
	int returnVal = 0, r_val;
	int j, k, size, size2, len;
	unsigned char ucVal;
	arraylist_t *temp_ary;
	HANDLE hFile;
	DWORD dwWriteSize;
	TCHAR path_str[MAX_PATH + 50];
	
	// pX߂
	len = lstrlen(fileName);
	if (len >= MAX_PATH + 40) {
		returnVal = -1;
		goto errorLabel;
	}
	lstrcpyn(path_str, fileName, len + 1);
	
	// pXύX(.png  .tal)
	lstrcpyn(PathFindExtension(path_str), MY_LIB_EXTENSION, lstrlen(MY_LIB_EXTENSION) + 1);
	
	// t@C
	hFile = CreateFile(path_str, GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		returnVal = -2;
		goto endLabel;
	}
	
	
	
	// o[WL^
	ucVal = 0x00;
	r_val = WriteFile(hFile, &ucVal, 1, &dwWriteSize, NULL);
	if (r_val == 0) { returnVal = -2; goto errorLabel; }
	
	size = arraylist_length(mask_data);
	//printf("all_size : %d\n", size);
	
	// p^[L^
	ucVal = ((size / 2) >> 8) & 0xFF;
	r_val = WriteFile(hFile, &ucVal, 1, &dwWriteSize, NULL);
	if (r_val == 0) { returnVal = -2; goto errorLabel; }
	ucVal = (size / 2) & 0xFF;
	r_val = WriteFile(hFile, &ucVal, 1, &dwWriteSize, NULL);
	if (r_val == 0) { returnVal = -2; goto errorLabel; }
	
	for (j = 0; j < size; j+=2) {
		// wb_[
		temp_ary = *((arraylist_t **)(arraylist_get(mask_data, j)));
		size2 = arraylist_length(temp_ary);
		//printf("header_size : %d\n", size2);
		for (k = 0; k < size2; k++) {
			ucVal = *((unsigned *)(arraylist_get(temp_ary, k)));
			//printf("%02X ", ucVal);
			r_val = WriteFile(hFile, &ucVal, 1, &dwWriteSize, NULL);
			if (r_val == 0) {
				returnVal = -2;
				goto errorLabel;
			}
		}
		// f[^
		temp_ary = *((arraylist_t **)(arraylist_get(mask_data, j + 1)));
		size2 = arraylist_length(temp_ary) - 1; // Ō1oCgɕf[^̕tO邪Ȃ
		//printf("body_size : %d\n", size2);
		for (k = 0; k < size2; k++) {
			ucVal = *((unsigned *)(arraylist_get(temp_ary, k)));
			//printf("%02X ", ucVal);
			r_val = WriteFile(hFile, &ucVal, 1, &dwWriteSize, NULL);
			if (r_val == 0) {
				returnVal = -2;
				goto errorLabel;
			}
		}
	}
	
	
	
	errorLabel:
	CloseHandle(hFile);
	
	endLabel:
	
	if      (returnVal == -1) lstrcpy(error_str, _T("t@CpX܂"));
	else if (returnVal == -2) lstrcpy(error_str, _T("t@C݂Ɏs"));
	
	return returnVal;
}
