
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ArrayList_t.h"

// Izۂz //

#define ALLAYLIST_ADDMEMSIZE 1024





// Iz𐶐 //
arraylist_t *arraylist_create(size_t size) {
	arraylist_t *t;
	t = (arraylist_t *)malloc(sizeof(arraylist_t));
	if (t == NULL) {
		return NULL;
	}
	t->data_size = size;
	t->mem = malloc(ALLAYLIST_ADDMEMSIZE * t->data_size);
	if (t->mem == NULL) {
		free(t);
		return NULL;
	}
	t->memlen = ALLAYLIST_ADDMEMSIZE;
	t->len = 0;
	
	return t;
}

// vfǉ ///////////////////////////////////////////////////////////
// |C^ǉ
int arraylist_add(arraylist_t *t, void *data) {
	if (t != NULL) {
		if (t->len >= t->memlen) {
			t->mem = realloc(t->mem, (t->memlen + ALLAYLIST_ADDMEMSIZE) * sizeof(t->data_size));
			if (t->mem == NULL) {
				return -1;
			}
			t->memlen += ALLAYLIST_ADDMEMSIZE;
		}
		memcpy((char *)t->mem + (t->len * t->data_size), data, t->data_size);
		t->len ++;
		
		return 0;
	} else {
		return -1;
	}
}

// charǉ
int arraylist_char_add(arraylist_t *t, char data) {
	if (t != NULL) {
		if (t->data_size != sizeof(char)) return -1;
		if (t->len >= t->memlen) {
			t->mem = realloc(t->mem, (t->memlen + ALLAYLIST_ADDMEMSIZE) * sizeof(t->data_size));
			if (t->mem == NULL) {
				return -1;
			}
			t->memlen += ALLAYLIST_ADDMEMSIZE;
		}
		memcpy((char *)t->mem + (t->len * sizeof(char)), &data, sizeof(char));
		t->len ++;
		
		return 0;
	} else {
		return -1;
	}
}

// unsigned charǉ
int arraylist_uchar_add(arraylist_t *t, unsigned char data) {
	if (t != NULL) {
		if (t->data_size != sizeof(unsigned char)) return -1;
		if (t->len >= t->memlen) {
			t->mem = realloc(t->mem, (t->memlen + ALLAYLIST_ADDMEMSIZE) * sizeof(t->data_size));
			if (t->mem == NULL) {
				return -1;
			}
			t->memlen += ALLAYLIST_ADDMEMSIZE;
		}
		memcpy((char *)t->mem + (t->len * sizeof(char)), &data, sizeof(unsigned char));
		t->len ++;
		
		return 0;
	} else {
		return -1;
	}
}

// intǉ
int arraylist_int_add(arraylist_t *t, int data) {
	if (t != NULL) {
		if (t->data_size != sizeof(int)) return -1;
		if (t->len >= t->memlen) {
			t->mem = realloc(t->mem, (t->memlen + ALLAYLIST_ADDMEMSIZE) * sizeof(t->data_size));
			if (t->mem == NULL) {
				return -1;
			}
			t->memlen += ALLAYLIST_ADDMEMSIZE;
		}
		memcpy((char *)t->mem + (t->len * sizeof(char)), &data, sizeof(int));
		t->len ++;
		
		return 0;
	} else {
		return -1;
	}
}

// unsigned intǉ
int arraylist_uint_add(arraylist_t *t, unsigned int data) {
	if (t != NULL) {
		if (t->data_size != sizeof(unsigned int)) return -1;
		if (t->len >= t->memlen) {
			t->mem = realloc(t->mem, (t->memlen + ALLAYLIST_ADDMEMSIZE) * sizeof(t->data_size));
			if (t->mem == NULL) {
				return -1;
			}
			t->memlen += ALLAYLIST_ADDMEMSIZE;
		}
		memcpy((char *)t->mem + (t->len * sizeof(char)), &data, sizeof(unsigned int));
		t->len ++;
		
		return 0;
	} else {
		return -1;
	}
}
/////////////////////////////////////////////////////////////////////////


// vf擾 //
void *arraylist_get(arraylist_t *t, int idx) {
	if (t != NULL) {
		if (idx < t->len) {
			return (void *)((char *)t->mem + (idx * t->data_size));
		}
		return NULL;
	} else {
		return NULL;
	}
}

// vf擾 //
int arraylist_length(arraylist_t *t) {
	return t->len;
}

// vfɂ //
int arraylist_clear(arraylist_t *t) {
	if (t != NULL) {
		free(t->mem);
		t->mem = malloc(ALLAYLIST_ADDMEMSIZE * sizeof(unsigned char));
		if (t->mem == NULL) {
			return -1;
		}
		t->memlen = ALLAYLIST_ADDMEMSIZE;
		t->len = 0;
		return 0;
	} else {
		return -1;
	}
}

// Iz폜 //
void arraylist_release(arraylist_t *t) {
	if (t != NULL) {
		if (t->mem != NULL) free(t->mem);
		free(t);
	}
}

