
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <tchar.h>
#include "png.h"
#include "pngconf.h"

#include "PngFunc.h"



static void PngReadFileCallback(png_structp Png, png_bytep buf, png_size_t len);



int fileLoadPng(LPCTSTR filePath, unsigned int **img_buf, loadPngInfo_t *loadPngInfo, LPTSTR error_str) {
	HANDLE hFile;
	DWORD  dwReadLen;
	BOOL   bRVal;
	int returnVal = 0;
	//FILE        *fp;
	png_structp  png;
	png_infop    png_info;
	
	unsigned int  width, height;
	int           bit_depth, color_type, interlace_type, byte_depth;
	int           number_of_passes;
	png_bytepp    temp_buf;
	int           i, j;
	png_byte      sig[8];
	
	
	// t@CI[v
	//fp = fopen(filePath, "rb");
	//if (fp == NULL) return NULL;
	hFile = CreateFile(filePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if (hFile == INVALID_HANDLE_VALUE) {
    	lstrcpy(error_str, _T("t@CJ܂"));
		returnVal = -1;
    	goto errorLabel;
    }
	
	// t@Cǂݍ
	bRVal = ReadFile(hFile, sig, 8, &dwReadLen, NULL);
	if (bRVal == 0) {
    	lstrcpy(error_str, _T("t@Cǂݍ݂Ɏs"));
		returnVal = -2;
		goto fcloseLabel;
	}
	
	// t@C`FbN
	if (!png_check_sig(sig, 8)) {
    	lstrcpy(error_str, "PNGt@Č`ł͂܂");
		returnVal = -3;
		goto fcloseLabel;
    }
	
	// png_structp\̂̃m
	png = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	if (png == NULL) {
    	lstrcpy(error_str, _T("mۂɎs"));
		returnVal = -4;
		goto fcloseLabel;
	}
	
	// png_infop\̂̃m
	png_info = png_create_info_struct(png);
	if (png == NULL) {
		png_destroy_read_struct(&png, NULL, NULL);
    	lstrcpy(error_str, _T("mۂɎs"));
		returnVal = -5;
		goto fcloseLabel;
	}
	
	
	// 
	if (setjmp(png_jmpbuf(png))) {
    	lstrcpy(error_str, _T("G["));
		returnVal = -6;
		goto structCloseLabel;
	}
	
	
	// t@C|C^̃Zbg
	//png_init_io(png, fp);
	png_set_read_fn(png, hFile, PngReadFileCallback);
	
	// OɃVOl`ǍmFςȂAt@C擪ǂݔ΂ĂoCgm点
	//png_set_sig_bytes(png, 8);
	png_set_sig_bytes(png, 8);
	
	
	
	// PNGt@Cwb_ǂݍ
	png_read_info(png, png_info);
	
	// IHDR`N擾
    png_get_IHDR(png, png_info, &width, &height, &bit_depth, &color_type, &interlace_type, NULL, NULL);
	//printf("ϊO:\nwidth: %d\nheight: %d\nbit_depth: %d\ncolor_type: %d\ninterlace_type: %d\n"
	//       , width, height, bit_depth, color_type, interlace_type);
	
	// loadPngInfo\̂ɏn
	memset(loadPngInfo, 0, sizeof(loadPngInfo));
	loadPngInfo->width          = width;
	loadPngInfo->height         = height;
	loadPngInfo->bit_depth      = bit_depth;
	loadPngInfo->byte_depth     = bit_depth/8 * 4;
	loadPngInfo->color_type     = color_type;
	loadPngInfo->interlace_type = interlace_type;
	
	
	// PNGȊO͏Ȃ
	if (color_type != 4 && color_type != 6) {
    	lstrcpy(error_str, _T("At@[tPNGł͂Ȃ߁A͂܂"));
		returnVal = -7;
		goto structCloseLabel;
	}
	
	
    // C^[[XɂΉ
	if (interlace_type == PNG_INTERLACE_ADAM7) {
		number_of_passes = png_set_interlace_handling(png);
	}
	
	
	
	// 摜̋L`ϊ //
    // pbgt摜RGB`ɕϊ
    if (color_type == PNG_COLOR_TYPE_PALETTE) {
    	png_set_palette_to_rgb(png);
    }
    // 8rbg8rbgɊg
	if (bit_depth < 8) {
		png_set_packing(png);
	}
	// 16rbg8rbgɏk
	if (bit_depth == 16) {
		png_set_strip_16(png);
	}
	// OCXP[摜RGB`ɕϊ
	if (color_type == PNG_COLOR_TYPE_GRAY || color_type == PNG_COLOR_TYPE_GRAY_ALPHA) {
		png_set_gray_to_rgb(png);
	}
	if (png_get_valid(png, png_info, PNG_INFO_tRNS)) {
	    // tRNS`N PNG̎dlƂĊSȃAt@`lƓȂ
	    // tRNS`NSȃAt@`lɕϊ
	    png_set_tRNS_to_alpha(png);
	} else if (!(color_type & PNG_COLOR_MASK_ALPHA)) {
	    // tRNS`NASȃAt@`l
	    // sŖ߂SȃAt@`lǉ
	    png_set_add_alpha(png, 0xff, PNG_FILLER_AFTER); // 32bitFɕϊ
	}
	png_set_bgr(png); // RGBтBGRтɕϊ
    png_read_update_info(png, png_info); // XV
	
	
	
	// IHDR`N܂擾
	png_get_IHDR(png, png_info, &width, &height, &bit_depth, &color_type, &interlace_type, NULL, NULL);
	byte_depth = bit_depth/8 * 4; // PsNZoCggvZ
	
	//printf("ϊ:\nwidth: %d\nheight: %d\nbit_depth: %d\ncolor_type: %d\ninterlace_type: %d\n"
	//       , width, height, bit_depth, color_type, interlace_type);
	
	
	
	// 摜f[^̃m //
	temp_buf = (png_bytepp)malloc(height * sizeof(png_bytep));
	if (temp_buf == NULL) {
    	lstrcpy(error_str, _T("mۂɎs"));
		returnVal = -9;
		goto structCloseLabel;
	}
	for (i = 0; i < (int)height; i++) {
		temp_buf[i] = (png_bytep)malloc(png_get_rowbytes(png, png_info));
		if (temp_buf[i] == NULL) {
	    	lstrcpy(error_str, _T("mۂɎs"));
			for (j = 0; j < i; j++) free(temp_buf[j]);
			free(temp_buf);
			returnVal = -9;
			goto structCloseLabel;
		}
	}
	
	
	*img_buf = (unsigned int *)malloc(width * height * (unsigned int)sizeof(img_buf));
	if (*img_buf == NULL) {
    	lstrcpy(error_str, _T("mۂɎs"));
		returnVal = -10;
		goto tempMemCloseLabel;
	}
	
	
	// 摜f[^ǂݍ //
	png_read_image(png, temp_buf);
	
	// oCgunsigned long̓ꕨɓ //
	// 32bitBGRA`ɕϊ
	for (j = 0; j < (int)(height); j ++) {
		for (i = 0; i < (int)(width); i ++) {
			(*img_buf)[i + j * width] = 
					((temp_buf[j][i * 4 + 0] & 0xFF) << 24) + 
					((temp_buf[j][i * 4 + 1] & 0xFF) << 16) + 
					((temp_buf[j][i * 4 + 2] & 0xFF) <<  8) + 
					((temp_buf[j][i * 4 + 3] & 0xFF)      );
					
		}
	}
	
	
    png_read_end(png, NULL);
	
	tempMemCloseLabel:
	// 摜f[^̃
	if (temp_buf) {
		for (i = 0; i < (int)height; i++) {
			if (temp_buf[i]) {
				free(temp_buf[i]);
			}
		}
		free(temp_buf);
	}
	
	structCloseLabel:
	// Q̍\̂̃
	png_destroy_read_struct(
			&png, &png_info, (png_infopp)NULL);
	
	
	fcloseLabel:
	// t@CN[Y
	CloseHandle(hFile);
	//fclose(fp);
	
	errorLabel:
	
	
	
	return returnVal;
}


//t@Cǂ݂݂̃R[obN֐B
static void PngReadFileCallback(png_structp Png, png_bytep buf, png_size_t len) {
	DWORD dwReadLen;
	HANDLE hFile = (HANDLE)png_get_io_ptr(Png); //̊֐png_set_read_fnŎw肵hFile擾łB
	ReadFile(hFile, buf, (DWORD)len, &dwReadLen, NULL);
}


